package com.ibm.vap.cciadapter;

/*
 * Source File Name : VapRecord.java
 * Licensed Materials - Property of IBM
 * 5655-F37
 * (C) Copyright IBM Corp. 1983, 2002. All Rights Reserved.
 */
 import java.io.*;
/**
 * Class used for input an output stream to communicate with the server.
 * @since 2.5v11
 */
public class VapRecord implements javax.resource.cci.Record, javax.resource.cci.Streamable {
	protected byte[] buffer;
	protected CCIAdapter cciAdapter;
	private final static String copyright = "Licensed Materials - Property of IBM\n5655-F37\n(C) Copyright IBM Corp. 1983, 2002. All Rights Reserved.\nUS Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP\nSchedule Contract with IBM Corp.";	
public VapRecord(int length, CCIAdapter cciAdapter) {
	super();
	this.cciAdapter = cciAdapter;
	buffer = new byte[length];
}
public VapRecord(CCIAdapter cciAdapter) {
	super();
	this.cciAdapter = cciAdapter;
}
/**
 * getRecordName method comment.
 */
public Object clone() {
	return null;
}
/**
 * Retrieves the length of the buffer attribut.
 * @return the buffer length
 */
public int getBufferLength() throws java.io.IOException {
	return buffer.length;
}
protected String getHostCodePage() {
	return cciAdapter.getHostCodePage();
}
/**
 * This method is use to retrieve in the given parameter char array the message
 * stored inthe byte array buffer
 * @param mess is the char array in which transfer the buffer
 * @param offset defines the starting byte to retrieve
 * @param length to retrieve
 */
public void getMessage(char[] mess, int offset, int length) throws java.io.IOException {
	try {
		String out = new String(buffer, offset, length, getHostCodePage());
		out.getChars(0, length, mess, offset);
	} catch (java.io.UnsupportedEncodingException uee) {
		throw new com.ibm.vap.generic.CommunicationError("Byte to Char Conversion Error", uee);
	}
}
/**
 * We do not need to implement the method.
 */
public String getRecordName() {
	return null;
}
/**
 * We do not need to implement the method.
 */
public String getRecordShortDescription() {
	return null;
}
/**
 * Reads the InputStream in the buffer array.
 * @param arg1 InputStream to read in the buffer array
 */
public void read(java.io.InputStream arg1) throws java.io.IOException {
	arg1.read(buffer);
}
/**
 * Transfer the input message in the buffer array.
 * @param mess to be transfered in the byte array
 * @param offset defines the starting position
 * @param length of the message to transfer
 */
public void setMessage(char[] mess, int offset, int length) throws java.io.IOException {
	try {
		buffer = new String(mess, offset, length).getBytes(getHostCodePage());
	} catch (java.io.UnsupportedEncodingException uee) {
		throw new com.ibm.vap.generic.CommunicationError("Char to Byte Conversion Error", uee);
	}
}
/**
 * We do not need to implement the method.
 */
public void setRecordName(String arg1) {}
/**
 * We do not need to implement the method.
 */
public void setRecordShortDescription(String arg1) {}
/**
 * Writes the OutputStream in the buffer array.
 * @param arg1 OutputStream to write to the buffer array
 */
public void write(java.io.OutputStream arg1) throws java.io.IOException {
	arg1.write(buffer);
}
}
